libssl.so.6 dependency in binary tarballs for latest 5.1/5.5/5.6 releases | mysqld: error while loading shared libraries: libssl.so.6: cannot open shared object file: No such file

Bug #1172916 reported by Roel Van de Paar on 2013-04-25
64
This bug affects 13 people
Affects Status Importance Assigned to Milestone
Percona Server
Status tracked in 5.6
5.1
High
Tomislav Plavcic
5.5
High
Tomislav Plavcic
5.6
High
Tomislav Plavcic
Percona XtraBackup
High
Ignacio Nin
2.0
High
Ignacio Nin
2.1
High
Ignacio Nin

Bug Description

/ssd/Percona-Server-5.5.30-rel30.2-500.Linux.x86_64/bin/mysqld: error while loading shared libraries: libssl.so.6: cannot open shared object file: No such file

As discussed w/ Ignacio. Consider static linking.

Workaround:
yum install openssl098e
   # note this can be installed just fine as an extra package next to latest openssl package already being present

Related branches

lp:~ignacio-nin/percona-xtrabackup/2.0-bug1172916
Merged into lp:percona-xtrabackup/2.0 at revision 575
Alexey Kopytov: Approve on 2013-07-30
lp:~ignacio-nin/percona-xtrabackup/2.1-bug1172916
Merged into lp:percona-xtrabackup/2.1 at revision 653
Alexey Kopytov: Approve on 2013-07-30
tags: added: pkg

I don't think static linking is good here. This looks like a bug with our
build system - our centos6 build slave may be out of date.
On Apr 25, 2013 2:45 PM, "RoelV" <email address hidden> wrote:
>
> Public bug reported:
>
> /ssd/Percona-Server-5.5.30-rel30.2-500.Linux.x86_64/bin/mysqld: error
> while loading shared libraries: libssl.so.6: cannot open shared object
> file: No such file
>
> As discussed w/ Ignacio. Consider static linking.
>
> Workaround:
> yum install openssl098e
> # note this can be installed just fine as an extra package next to
latest openssl package already being present
>
> ** Affects: percona-server
> Importance: Undecided
> Assignee: Ignacio Nin (ignacio-nin)
> Status: New
>
> ** Affects: percona-server/5.1
> Importance: Undecided
> Status: New
>
> ** Affects: percona-server/5.5
> Importance: High
> Assignee: Ignacio Nin (ignacio-nin)
> Status: Confirmed
>
> ** Affects: percona-server/5.6
> Importance: Undecided
> Assignee: Ignacio Nin (ignacio-nin)
> Status: New
>
>
> ** Tags: qa
>
> ** Also affects: percona-server/5.1
> Importance: Undecided
> Status: New
>
> ** Also affects: percona-server/5.5
> Importance: Undecided
> Status: New
>
> ** Also affects: percona-server/5.6
> Importance: High
> Assignee: Ignacio Nin (ignacio-nin)
> Status: Confirmed
>
> ** Changed in: percona-server/5.6
> Importance: High => Undecided
>
> ** Changed in: percona-server/5.5
> Importance: Undecided => High
>
> ** Changed in: percona-server/5.5
> Assignee: (unassigned) => Ignacio Nin (ignacio-nin)
>
> ** Changed in: percona-server/5.6
> Status: Confirmed => New
>
> ** Changed in: percona-server/5.5
> Status: New => Confirmed
>
> --
> You received this bug notification because you are a member of Percona
> core, which is subscribed to Percona Server.
> Matching subscriptions: percona-server
> https://bugs.launchpad.net/bugs/1172916
>
> Title:
> PS 5.5.30.2 fails to run on Centos6 | mysqld: error while loading
> shared libraries: libssl.so.6: cannot open shared object file: No such
> file
>
> Status in Percona Server with XtraDB:
> New
> Status in Percona Server 5.1 series:
> New
> Status in Percona Server 5.5 series:
> Confirmed
> Status in Percona Server 5.6 series:
> New
>
> Bug description:
> /ssd/Percona-Server-5.5.30-rel30.2-500.Linux.x86_64/bin/mysqld: error
> while loading shared libraries: libssl.so.6: cannot open shared object
> file: No such file
>
> As discussed w/ Ignacio. Consider static linking.
>
> Workaround:
> yum install openssl098e
> # note this can be installed just fine as an extra package next to
latest openssl package already being present
>
> To manage notifications about this bug go to:
> https://bugs.launchpad.net/percona-server/+bug/1172916/+subscriptions

Download full text (3.3 KiB)

To add, when built with system SSL, it is linked against SSL library of the
system, so probably system was on libssl6 than libssl10 (which is the
standard on centos 6.4 i believe) .
On Apr 26, 2013 10:18 AM, "Raghavendra Prabhu" <
<email address hidden>> wrote:

> I don't think static linking is good here. This looks like a bug with our
> build system - our centos6 build slave may be out of date.
> On Apr 25, 2013 2:45 PM, "RoelV" <email address hidden> wrote:
> >
> > Public bug reported:
> >
> > /ssd/Percona-Server-5.5.30-rel30.2-500.Linux.x86_64/bin/mysqld: error
> > while loading shared libraries: libssl.so.6: cannot open shared object
> > file: No such file
> >
> > As discussed w/ Ignacio. Consider static linking.
> >
> > Workaround:
> > yum install openssl098e
> > # note this can be installed just fine as an extra package next to
> latest openssl package already being present
> >
> > ** Affects: percona-server
> > Importance: Undecided
> > Assignee: Ignacio Nin (ignacio-nin)
> > Status: New
> >
> > ** Affects: percona-server/5.1
> > Importance: Undecided
> > Status: New
> >
> > ** Affects: percona-server/5.5
> > Importance: High
> > Assignee: Ignacio Nin (ignacio-nin)
> > Status: Confirmed
> >
> > ** Affects: percona-server/5.6
> > Importance: Undecided
> > Assignee: Ignacio Nin (ignacio-nin)
> > Status: New
> >
> >
> > ** Tags: qa
> >
> > ** Also affects: percona-server/5.1
> > Importance: Undecided
> > Status: New
> >
> > ** Also affects: percona-server/5.5
> > Importance: Undecided
> > Status: New
> >
> > ** Also affects: percona-server/5.6
> > Importance: High
> > Assignee: Ignacio Nin (ignacio-nin)
> > Status: Confirmed
> >
> > ** Changed in: percona-server/5.6
> > Importance: High => Undecided
> >
> > ** Changed in: percona-server/5.5
> > Importance: Undecided => High
> >
> > ** Changed in: percona-server/5.5
> > Assignee: (unassigned) => Ignacio Nin (ignacio-nin)
> >
> > ** Changed in: percona-server/5.6
> > Status: Confirmed => New
> >
> > ** Changed in: percona-server/5.5
> > Status: New => Confirmed
> >
> > --
> > You received this bug notification because you are a member of Percona
> > core, which is subscribed to Percona Server.
> > Matching subscriptions: percona-server
> > https://bugs.launchpad.net/bugs/1172916
> >
> > Title:
> > PS 5.5.30.2 fails to run on Centos6 | mysqld: error while loading
> > shared libraries: libssl.so.6: cannot open shared object file: No such
> > file
> >
> > Status in Percona Server with XtraDB:
> > New
> > Status in Percona Server 5.1 series:
> > New
> > Status in Percona Server 5.5 series:
> > Confirmed
> > Status in Percona Server 5.6 series:
> > New
> >
> > Bug description:
> > /ssd/Percona-Server-5.5.30-rel30.2-500.Linux.x86_64/bin/mysqld: error
> > while loading shared libraries: libssl.so.6: cannot open shared object
> > file: No such file
> >
> > As discussed w/ Ignacio. Consider static linking.
> >
> > Workaround:
> > yum install openssl098e
> > # note this can be installed just fine as an extra package next to...

Read more...

no longer affects: percona-xtradb-cluster

Neither recent 5.1.x, nor recent 5.6.x ta.gz binaries are affected:

[openxs@chief tmp]$ ldd Percona-Server-5.1.68-rel14.6-551.Linux.x86_64/libexec/mysqld
        linux-vdso.so.1 => (0x00007fff14dd7000)
        libpthread.so.0 => /lib64/libpthread.so.0 (0x0000003ffac00000)
        libz.so.1 => /lib64/libz.so.1 (0x0000003ffbc00000)
        libdl.so.2 => /lib64/libdl.so.2 (0x0000003ffb000000)
        librt.so.1 => /lib64/librt.so.1 (0x0000003ffb400000)
        libcrypt.so.1 => /lib64/libcrypt.so.1 (0x0000003007000000)
        libnsl.so.1 => /lib64/libnsl.so.1 (0x000000300b800000)
        libm.so.6 => /lib64/libm.so.6 (0x0000003ffb800000)
        libc.so.6 => /lib64/libc.so.6 (0x0000003ffa800000)
        /lib64/ld-linux-x86-64.so.2 (0x0000003ffa400000)
        libfreebl3.so => /lib64/libfreebl3.so (0x0000003006400000)

[openxs@chief tmp]$ ldd Percona-Server-5.6.10-alpha60.2-324.Linux.x86_64/bin/mysqld linux-vdso.so.1 => (0x00007fff7d3ff000)
        libpthread.so.0 => /lib64/libpthread.so.0 (0x0000003ffac00000)
        libaio.so.1 => /lib64/libaio.so.1 (0x00000035b9000000)
        librt.so.1 => /lib64/librt.so.1 (0x0000003ffb400000)
        libcrypt.so.1 => /lib64/libcrypt.so.1 (0x0000003007000000)
        libdl.so.2 => /lib64/libdl.so.2 (0x0000003ffb000000)
        libstdc++.so.6 => /usr/lib64/libstdc++.so.6 (0x0000003006000000)
        libm.so.6 => /lib64/libm.so.6 (0x0000003ffb800000)
        libgcc_s.so.1 => /lib64/libgcc_s.so.1 (0x0000003ffc000000)
        libc.so.6 => /lib64/libc.so.6 (0x0000003ffa800000)
        /lib64/ld-linux-x86-64.so.2 (0x0000003ffa400000)
        libfreebl3.so => /lib64/libfreebl3.so (0x0000003006400000)

Compare to 5.5.30-30.2:

[openxs@chief tmp]$ ldd Percona-Server-5.5.30-rel30.2-500.Linux.x86_64/bin/mysqld
        linux-vdso.so.1 => (0x00007fffeebff000)
        libpthread.so.0 => /lib64/libpthread.so.0 (0x0000003ffac00000)
        libaio.so.1 => /lib64/libaio.so.1 (0x00000035b9000000)
        libm.so.6 => /lib64/libm.so.6 (0x0000003ffb800000)
        librt.so.1 => /lib64/librt.so.1 (0x0000003ffb400000)
        libcrypt.so.1 => /lib64/libcrypt.so.1 (0x0000003007000000)
        libdl.so.2 => /lib64/libdl.so.2 (0x0000003ffb000000)
        libssl.so.6 => not found
        libcrypto.so.6 => not found
        libc.so.6 => /lib64/libc.so.6 (0x0000003ffa800000)
        /lib64/ld-linux-x86-64.so.2 (0x0000003ffa400000)
        libfreebl3.so => /lib64/libfreebl3.so (0x0000003006400000)

Alexey Kopytov (akopytov) wrote :

The latest 5.1 and 5.6 tarballs are also affected. It's also not RHEL-specific, but based on a XB Jenkins param build, affects all supported platforms. Verified on Ubuntu 13.04:

$ Percona-Server-5.1.69-rel14.7-572.Linux.x86_64/libexec/mysqld
Percona-Server-5.1.69-rel14.7-572.Linux.x86_64/libexec/mysqld: error while loading shared libraries: libssl.so.6: cannot open shared object file: No such file or directory

$ Percona-Server-5.5.31-rel30.3-520.Linux.x86_64/bin/mysqld
Percona-Server-5.5.31-rel30.3-520.Linux.x86_64/bin/mysqld: error while loading shared libraries: libssl.so.6: cannot open shared object file: No such file or directory

$ Percona-Server-5.6.11-rc60.3-375.Linux.x86_64/bin/mysqld
Percona-Server-5.6.11-rc60.3-375.Linux.x86_64/bin/mysqld: error while loading shared libraries: libssl.so.6: cannot open shared object file: No such file or directory

$ dpkg -l | grep ssl
ii libio-socket-ssl-perl 1.76-2ubuntu1 all Perl module implementing object oriented interface to SSL sockets
ii libnet-ssleay-perl 1.48-1 amd64 Perl module for Secure Sockets Layer (SSL)
ii libssl-dev 1.0.1c-4ubuntu8 amd64 SSL development libraries, header files and documentation
ii libssl-doc 1.0.1c-4ubuntu8 all SSL development documentation documentation
ii libssl0.9.8:amd64 0.9.8o-7ubuntu3.1 amd64 SSL shared libraries
ii libssl1.0.0:amd64 1.0.1c-4ubuntu8 amd64 SSL shared libraries
ii openssl 1.0.1c-4ubuntu8 amd64 Secure Socket Layer (SSL) binary and related cryptographic tools
ii python-openssl 0.13-2ubuntu3 amd64 Python 2 wrapper around the OpenSSL library

summary: - PS 5.5.30.2 fails to run on Centos6 | mysqld: error while loading shared
- libraries: libssl.so.6: cannot open shared object file: No such file
+ libssl.so.6 dependency in binary tarballs for latest 5.1/5.5/5.6
+ releases | mysqld: error while loading shared libraries: libssl.so.6:
+ cannot open shared object file: No such file
Alexey Kopytov (akopytov) wrote :

There is no openssl098 package available on Ubuntu 13.04. There are:

ii libssl0.9.8:amd64 0.9.8o-7ubuntu3.1 amd64 SSL shared libraries
ii libssl1.0.0:amd64 1.0.1c-4ubuntu8 amd64 SSL shared libraries
ii openssl 1.0.1c-4ubuntu8 amd64 Secure Socket Layer (SSL) binary and related cryptographic tools

But installing all of them does not resolve the issue.

Alexey Kopytov (akopytov) wrote :

$ ldd Percona-Server-5.5.31-rel30.3-520.Linux.x86_64/bin/mysqld
 linux-vdso.so.1 => (0x00007fff79f1f000)
 libpthread.so.0 => /lib/x86_64-linux-gnu/libpthread.so.0 (0x00007f2298831000)
 libaio.so.1 => /lib/x86_64-linux-gnu/libaio.so.1 (0x00007f229862f000)
 libm.so.6 => /lib/x86_64-linux-gnu/libm.so.6 (0x00007f2298329000)
 librt.so.1 => /lib/x86_64-linux-gnu/librt.so.1 (0x00007f2298121000)
 libcrypt.so.1 => /lib/x86_64-linux-gnu/libcrypt.so.1 (0x00007f2297ee8000)
 libdl.so.2 => /lib/x86_64-linux-gnu/libdl.so.2 (0x00007f2297ce3000)
 libssl.so.6 => not found
 libcrypto.so.6 => not found
 libc.so.6 => /lib/x86_64-linux-gnu/libc.so.6 (0x00007f229791a000)
 /lib64/ld-linux-x86-64.so.2 (0x00007f2298a5c000)

Compare to the binary installed from the Percona repository:

$ ldd /usr/sbin/mysqld
 linux-vdso.so.1 => (0x00007fffec9fe000)
 libaio.so.1 => /lib/x86_64-linux-gnu/libaio.so.1 (0x00007f7c649fb000)
 libm.so.6 => /lib/x86_64-linux-gnu/libm.so.6 (0x00007f7c646f6000)
 libpthread.so.0 => /lib/x86_64-linux-gnu/libpthread.so.0 (0x00007f7c644d8000)
 libcrypt.so.1 => /lib/x86_64-linux-gnu/libcrypt.so.1 (0x00007f7c6429f000)
 libdl.so.2 => /lib/x86_64-linux-gnu/libdl.so.2 (0x00007f7c6409b000)
 libssl.so.1.0.0 => /lib/x86_64-linux-gnu/libssl.so.1.0.0 (0x00007f7c63e3d000)
 libcrypto.so.1.0.0 => /lib/x86_64-linux-gnu/libcrypto.so.1.0.0 (0x00007f7c63a62000)
 libc.so.6 => /lib/x86_64-linux-gnu/libc.so.6 (0x00007f7c6369a000)
 /lib64/ld-linux-x86-64.so.2 (0x00007f7c64c0b000)
 libz.so.1 => /lib/x86_64-linux-gnu/libz.so.1 (0x00007f7c63482000)

Vlad Lesin (vlad-lesin) wrote :
Download full text (4.1 KiB)

I tried to link libssl statically under Ubuntu 13.04. But it depends on libz and there are unresolved symbols when libssl.a or librypto.a are linked.

There are two options what libz to use- "system" and "bundled". In the case of "bundled" there are no unresolved symbols in "bundled" version:

/usr/lib/ccache/c++ -fPIC -Wall -Wno-unused-parameter -O3 -DNDEBUG -DDBUG_OFF -DMY_PTHREAD_FASTMUTEX=1 CMakeFiles/comp_err.dir/comp_err.c.o -o comp_err -lpthread ../mysys/libmysys.a ../mysys_ssl/libmysys_ssl.a ../mysys/libmysys.a ../dbug/libdbug.a ../mysys/libmysys.a ../dbug/libdbug.a -lm ../strings/libstrings.a ../zlib/libzlib.a -lpthread -Wl,-Bstatic -lssl -lcrypto -Wl,-Bdynamic -ldl
/usr/lib/gcc/x86_64-linux-gnu/4.7/../../../x86_64-linux-gnu/libcrypto.a(c_zlib.o): In function `bio_zlib_free':
(.text+0x4d): undefined reference to `inflateEnd'
/usr/lib/gcc/x86_64-linux-gnu/4.7/../../../x86_64-linux-gnu/libcrypto.a(c_zlib.o): In function `bio_zlib_free':
(.text+0x6b): undefined reference to `deflateEnd'
/usr/lib/gcc/x86_64-linux-gnu/4.7/../../../x86_64-linux-gnu/libcrypto.a(c_zlib.o): In function `bio_zlib_ctrl':
(.text+0x284): undefined reference to `deflate'
/usr/lib/gcc/x86_64-linux-gnu/4.7/../../../x86_64-linux-gnu/libcrypto.a(c_zlib.o): In function `bio_zlib_ctrl':
(.text+0x342): undefined reference to `zError'
/usr/lib/gcc/x86_64-linux-gnu/4.7/../../../x86_64-linux-gnu/libcrypto.a(c_zlib.o): In function `zlib_stateful_expand_block':
(.text+0x411): undefined reference to `inflate'
/usr/lib/gcc/x86_64-linux-gnu/4.7/../../../x86_64-linux-gnu/libcrypto.a(c_zlib.o): In function `zlib_stateful_compress_block':
(.text+0x4ca): undefined reference to `deflate'
/usr/lib/gcc/x86_64-linux-gnu/4.7/../../../x86_64-linux-gnu/libcrypto.a(c_zlib.o): In function `zlib_stateful_finish':
(.text+0x51f): undefined reference to `inflateEnd'
/usr/lib/gcc/x86_64-linux-gnu/4.7/../../../x86_64-linux-gnu/libcrypto.a(c_zlib.o): In function `zlib_stateful_finish':
(.text+0x528): undefined reference to `deflateEnd'
/usr/lib/gcc/x86_64-linux-gnu/4.7/../../../x86_64-linux-gnu/libcrypto.a(c_zlib.o): In function `zlib_stateful_init':
(.text+0x5d7): undefined reference to `inflateInit_'
/usr/lib/gcc/x86_64-linux-gnu/4.7/../../../x86_64-linux-gnu/libcrypto.a(c_zlib.o): In function `zlib_stateful_init':
(.text+0x659): undefined reference to `deflateInit_'
/usr/lib/gcc/x86_64-linux-gnu/4.7/../../../x86_64-linux-gnu/libcrypto.a(c_zlib.o): In function `bio_zlib_read':
(.text+0x893): undefined reference to `inflate'
/usr/lib/gcc/x86_64-linux-gnu/4.7/../../../x86_64-linux-gnu/libcrypto.a(c_zlib.o): In function `bio_zlib_read':
(.text+0x90d): undefined reference to `zError'
/usr/lib/gcc/x86_64-linux-gnu/4.7/../../../x86_64-linux-gnu/libcrypto.a(c_zlib.o): In function `bio_zlib_read':
(.text+0x97c): undefined reference to `inflateInit_'
/usr/lib/gcc/x86_64-linux-gnu/4.7/../../../x86_64-linux-gnu/libcrypto.a(c_zlib.o): In function `bio_zlib_write':
(.text+0xa6f): undefined reference to `deflate'
/usr/lib/gcc/x86_64-linux-gnu/4.7/../../../x86_64-linux-gnu/libcrypto.a(c_zlib.o): In function `bio_zlib_write':
(.text+0xaec): undefined reference to `zError'
/usr/lib/gcc/x86_64-linux-gnu/4...

Read more...

Alexey Kopytov (akopytov) wrote :

Also affects XtraBackup binary tarballs according to https://bugs.launchpad.net/percona-xtrabackup/+bug/1168540/comments/1

I looked at using statifier - http://statifier.sourceforge.net/rrp_statify/main.html - and its RPM equivalent http://statifier.sourceforge.net/rrp_statify/ We have to either build the whole binary statically (with rrp_statify) or use statifier on resulting binary. Otherwise, the binary release is going to have issues being cross platform (which it is meant to be).

I looked at size of resulting binary, it was 11M v/s 18M
with/without statification.

Vlad Lesin (vlad-lesin) wrote :

There is "bundled" ssl library in upstream tarball.

nm mysql-5.6.12-linux-glibc2.5-x86_64/bin/mysqld | grep -i SSL_CTX_new
0000000000b6c9f0 t yaSSL_CTX_new

So I propose to use "bundled" ssl too for tarballs.

Al T (al-t) wrote :

Hello, I see Percona XtraDB CLuster was removed from this bug, however I see exactly that problem with binary distribution of PXC on SLES11SP2, it has openssl 0.9.8 only unfortunately. I've currently solved this by creating a symlink to the 0.9.8 library, however this is apparently not for production use.

Do you have any plans for fixing this for PXC binary distribution too?

@Al T,

The issue is with galera library, it is being handled separately in https://bugs.launchpad.net/percona-xtradb-cluster/+bug/1237444

Alexey Kopytov (akopytov) wrote :

The problem has not been fixed and is still present in the latest Percona Server releases. I.e. binary tarballs are only usable on RH/Centos.

Tested on Ubuntu Saucy, but according to Jenkins the same problem is on all supported Ubuntu and Debian releases:

$ Percona-Server-5.6.14-rel62.0-483.Linux.x86_64/bin/mysqldPercona-Server-5.6.14-rel62.0-483.Linux.x86_64/bin/mysqld: error while loading shared libraries: libssl.so.6: cannot open shared object file: No such file or directory

$ Percona-Server-5.5.34-rel32.0-591.Linux.x86_64/bin/mysqldPercona-Server-5.5.34-rel32.0-591.Linux.x86_64/bin/mysqld: error while loading shared libraries: libssl.so.6: cannot open shared object file: No such file or directory

$ Percona-Server-5.1.72-rel14.10-597.Linux.x86_64/libexec/mysqld
Percona-Server-5.1.72-rel14.10-597.Linux.x86_64/libexec/mysqld: error while loading shared libraries: libssl.so.6: cannot open shared object file: No such file or directory

Vadim Tkachenko (vadim-tk) wrote :

Alexey,

Are you sure you download a proper tarball ?
The one with -static in its name?
In my tests it was working fine.

Vadim Tkachenko (vadim-tk) wrote :

absence of static tarball is indeed packaging bug.
it should be added to release checklist

Looks like the static-openssl job was not run for 5.6.14 - http://jenkins.percona.com/view/PS%205.6/job/percona-server-5.6-binaries-static-openssl/ (last run for 5.6.13) and it is not a triggered job. Having a master release job like http://jenkins.percona.com/view/XtraDB-Cluster/job/percona-xtradb-cluster-RELEASE/ for PS should fix this (so that no jobs are forgotten).

Alexey Kopytov (akopytov) wrote :

I see we used to have -static-openssl tarballs for some recent releases, but not the latest ones, e.g.: http://www.percona.com/downloads/Percona-Server-5.6/Percona-Server-5.6.13-rel61.0/binary/linux/x86_64/

In this case, it makes sense to handle the problem with the latest releases separately (as it's a regression, rather than the original problem). Whoever will work on this, feel free to fork this bug into a separate one.

Matthew B (utdrmac) wrote :

I resolved my immediate issue with the following:

cd /usr/lib64
ln -s libssl.so libssl.so.6
ln -s libcrypto.so libcrypto.so.6

[root@stage-db ~]# cat /etc/redhat-release
CentOS release 6.5 (Final)

[root@stage-db lib64]# ls -la libcrypto*
lrwxrwxrwx 1 root root 19 Jan 9 04:36 libcrypto.so -> libcrypto.so.1.0.1e
lrwxrwxrwx 1 root root 19 Jan 9 04:36 libcrypto.so.10 -> libcrypto.so.1.0.1e
-rwxr-xr-x 1 root root 1950976 Jan 8 12:43 libcrypto.so.1.0.1e
lrwxrwxrwx 1 root root 12 Mar 11 14:04 libcrypto.so.6 -> libcrypto.so

[root@stage-db lib64]# ls -la libssl*
-rwxr-xr-x 1 root root 250168 Feb 11 07:01 libssl3.so
lrwxrwxrwx 1 root root 16 Jan 9 04:36 libssl.so -> libssl.so.1.0.1e
lrwxrwxrwx 1 root root 16 Jan 9 04:36 libssl.so.10 -> libssl.so.1.0.1e
-rwxr-xr-x 1 root root 437016 Jan 8 12:43 libssl.so.1.0.1e
lrwxrwxrwx 1 root root 9 Mar 11 14:04 libssl.so.6 -> libssl.so

Percona Server now starts

tags: added: i43711
Alexey Kopytov (akopytov) wrote :

This becomes even more painful as the same problem affects CentOS 7. That is, our tarballs are currently unusable on any Debian/Ubuntu hosts _and_ CentOS 7 hosts.

tags: added: i44044
sbester (sbester) wrote :

I just installed Fedora 20 and it had openssl-1.0.1e-38.fc20.x86_64 already.
Thus, I had do this in order to use Percona-Server-5.6.17-rel66.0-608.Linux.x86_64.tar.gz

cd /lib64
ln -s libcrypto.so.1.0.1e libcrypto.so.6
ln -s libssl.so.1.0.1e libssl.so.6

Al T (al-t) wrote :

Just want to reiterate on my earlier report - I'm now trying the Percona-Server-5.6.21-rel70.1-698.Linux.x86_64.tar.gz (latest release available for download) and it still has this libssl.so.6 dependency, just like PXC before, which doesn't work on SLES and this symlinking workaround is needed.

sbester (sbester) wrote :

Problem still exists for me on fedora 17 using: Percona-Server-5.6.22-rel71.0-726.Linux.x86_64.tar.gz

On my system I did this to solve:

cd /lib64
ln -s libcrypto.so.1.0.0k libcrypto.so.6
ln -s libssl.so.1.0.0k libssl.so.6

Michele (mds-half-deserted) wrote :

Just to add to this, I see the same behavior on a fresh installation of CentOS 6.6 using the binary installation tar file Percona-Server-5.6.22-rel72.0-738.Linux.x86_64.tar.gz.

This is with the latest version of openssl-devel provided by 6.6.

# rpm -qa | grep openssl
openssl-1.0.1e-30.el6_6.5.x86_64
openssl-devel-1.0.1e-30.el6_6.5.x86_64

$ ldd /usr/local/Percona-Server-5.6.22-rel72.0-738.Linux.x86_64/bin/mysqld
 linux-vdso.so.1 => (0x00007fffbf082000)
 libpthread.so.0 => /lib64/libpthread.so.0 (0x00007f0833349000)
 libaio.so.1 => /lib64/libaio.so.1 (0x00007f0833148000)
 librt.so.1 => /lib64/librt.so.1 (0x00007f0832f3f000)
 libcrypt.so.1 => /lib64/libcrypt.so.1 (0x00007f0832d08000)
 libssl.so.6 => not found
 libcrypto.so.6 => not found
 libdl.so.2 => /lib64/libdl.so.2 (0x00007f0832b03000)
 libstdc++.so.6 => /usr/lib64/libstdc++.so.6 (0x00007f08327fd000)
 libm.so.6 => /lib64/libm.so.6 (0x00007f0832578000)
 libgcc_s.so.1 => /lib64/libgcc_s.so.1 (0x00007f0832362000)
 libc.so.6 => /lib64/libc.so.6 (0x00007f0831fce000)
 /lib64/ld-linux-x86-64.so.2 (0x00007f0833570000)
 libfreebl3.so => /lib64/libfreebl3.so (0x00007f0831dca000)

Paul Namuag (paul-namuag) wrote :

Hi Michele,

can you run the command below:

yum provides libssl.so.6

If you see a package that has it, you might try to install that package and check with ldd again if it's properly loaded by MySQL.

tags: added: i51063
Tomislav Plavcic (tplavcic) wrote :

Since there is some conclusion that we shouldn't build with yassl (that all our packages and binary tarball should be built with openssl) and for security reasons seems we don't want static openssl builds the only solution I see is creating more then one binary tarball so that users can use the one that works out-of-the-box for them.

I did some testing and for now I'm settled on 4 builds:
- debian wheezy - to be used for all debian/ubuntu except squeeze
(libssl.so.1.0.0 => /usr/lib/x86_64-linux-gnu/libssl.so.1.0.0 (0x00007f2e389a5000))
- debian squeeze - only for squeeze and ubuntu lucid (which is irrelevant since it's EOL is 04/2015)
(libssl.so.0.9.8 => /usr/lib/libssl.so.0.9.8 (0x00007f9b30db6000))
- centos 6 - to be used for centos 6 and centos 7
(libssl.so.10 => /usr/lib64/libssl.so.10 (0x00007facbe8c4000))
- centos 5 - to be used only for centos 5
(libssl.so.6 => /lib64/libssl.so.6 (0x00002aed5b64d000))

Apart from adding more distros to jenkins matrix for release builds minor change in naming of binary tarball is necessary so that it reflects the distro on which it was built so that users know which one to use - probably a doc update somewhere will also be needed for this.

Tomislav Plavcic (tplavcic) wrote :

Tarball names will be something like:
Percona-Server-5.5.41-rel37.0-Linux.x86_64-ssl098e.tar.gz
- this one will be only for centos5 (version 0.9.8)

Percona-Server-5.5.41-rel37.0-Linux.x86_64-ssl098.tar.gz
- for debian 6 and ubuntu lucid (version 0.9.8)
- we need this one because the one from centos5 doesn't work out-of-the box

Percona-Server-5.5.41-rel37.0-Linux.x86_64-ssl100.tar.gz
- for other debian/ubuntu distros (libssl version 1.0.0)

Percona-Server-5.5.41-rel37.0-Linux.x86_64-ssl101.tar.gz
- for centos 6/7 (libssl version 1.0.1)

Although with vivid/jessie coming I think in the end we will have one tarball per distribution that we support (just like mongodb has) - but let's see how it goes.

To post a comment you must log in.
This report contains Public information  Edit
Everyone can see this information.

Duplicates of this bug

Other bug subscribers